class
	P_ABS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_abs (a_w, a_u: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_wp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_u.item.mp_size >= 0 then
				l_size := (a_u.item.mp_size).to_integer_32
			else
				l_size := (-a_u.item.mp_size).to_integer_32
			end
			if not a_u.is_equal (a_w) then
				if (a_w.item.mp_alloc).to_integer_32 < l_size then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_w, l_size).do_nothing
				end
				l_wp := a_w.item.mp_d
				l_up := a_u.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_wp, l_up, l_size)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
			end
			a_w.item.mp_size := l_size.to_integer_32
		end

end
