class
	P_ARRAY_INIT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_array_init (a_arr: CE_POINTER [PD_MPZ_STRUCT]; a_arr_size, a_nbits: INTEGER_32)
		local
			l_p: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_nlimbs: INTEGER_32
		do
			l_nlimbs := ((a_nbits + 32) - 1) // 32
			l_p := create {CE_NATURAL_32_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_GMP_IMPL_STATIC}).gmp_allocate_func.pointer_item ([((a_arr_size * l_nlimbs) * 4).to_natural_32]))))
			l_i := (0).to_integer_32
			from
			until
				not (l_i < a_arr_size)
			loop
				(a_arr + l_i).item.mp_alloc := (l_nlimbs + 1).to_integer_32;
				(a_arr + l_i).item.mp_size := 0;
				(a_arr + l_i).item.mp_d := l_p + l_i * l_nlimbs
				l_i := l_i + 1
			end
		end

end
