class
	P_CLEARS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_clears (a_args: TUPLE [a_x: CE_POINTER [PD_MPZ_STRUCT]])
		local
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_ap: CE_VA_LIST
		do
			create l_ap.make_shared (default_pointer)

			l_x := a_args.a_x
			l_ap := create {CE_VA_LIST}.make (a_args, agent gmpz_clears)
			from
			until
				l_x.is_void
			loop
				(create {P_CLEAR_STATIC}).gmpz_clear (l_x)
				l_x := (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ap.pointer_item))
			end
		end

end
