class
	P_KRONSZ_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_si_kronecker (a_a: INTEGER_32; a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_b_ptr: CE_POINTER [NATURAL_32]
			l_b_low: NATURAL_32
			l_b_size: INTEGER_32
			l_b_abs_size: INTEGER_32
			l_a_limb: NATURAL_32
			l_b_rem: NATURAL_32
			l_twos: NATURAL_32
			l_result_bit1: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_5: INTEGER_32
			l_a_ptr: CE_POINTER [NATURAL_32]
			l_a_size: INTEGER_32
			l_b: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_b_size := (a_b.item.mp_size).to_integer_32
			if l_b_size = 0 then
				Result := (((a_a = 1).to_integer).bit_or ((a_a = -1).to_integer))
				l_return := True
			end
			if not l_return then
				l_result_bit1 := ((((a_a < 0).to_integer).bit_and ((l_b_size < 0).to_integer))).bit_shift_left (1)
				l_b_ptr := a_b.item.mp_d
				l_b_low := l_b_ptr[0]
				if l_b_size >= 0 then
					l_b_abs_size := l_b_size
				else
					l_b_abs_size := -l_b_size
				end
				if ((l_b_low).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
					l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
					if a_a >= 0 then
						l_tmp := a_a
					else
						l_tmp := -a_a
					end
					l_a_limb := l_tmp.to_natural_32
					if ((l_a_limb).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
						if l_a_limb = {NATURAL_32} 0 then
							if l_b_abs_size = 1 then
								if l_b_low = {NATURAL_32} 1 then
									l_tmp_0 := 1
								else
									l_tmp_0 := 0
								end
							else
								l_tmp_0 := 0
							end
							Result := l_tmp_0
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_twos := (builtin_ctzl (l_a_limb)).to_natural_32
								l_break := True
							end
							l_break := False
							l_a_limb := (l_a_limb).bit_shift_right (l_twos.to_integer_32)
							l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_b_low).bit_shift_right (1))).bit_xor (l_b_low)).to_integer_32)))
						end
					end
				else
					if ((a_a).bit_and (1)) = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if not (builtin_expect ((l_b_low = {NATURAL_32} 0).to_integer, 0)).to_boolean then
									l_break := True
								end
								if not (l_return or l_break) then
									l_b_abs_size := l_b_abs_size - 1
									l_b_ptr := l_b_ptr + 1
									l_b_low := l_b_ptr.item
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_b_low).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							if (builtin_expect ((l_b_low = ({NATURAL_32} 1).bit_shift_left (31)).to_integer, 0)).to_boolean then
								if l_b_abs_size = 1 then
									l_result_bit1 := (l_result_bit1).bit_xor (((((a_a).bit_shift_right (1))).bit_xor (a_a)).to_integer_32)
									Result := (1 - ((l_result_bit1).bit_and (2)))
									l_return := True
								end
								if not l_return then
									l_b_low := ((l_b_ptr[1]).bit_shift_left (1))
								end
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_twos := (builtin_ctzl (l_b_low)).to_natural_32
									l_break := True
								end
								l_break := False
								l_b_low := (l_b_low).bit_shift_right (l_twos.to_integer_32)
							end
						end
					end
					if not l_return then
						l_result_bit1 := (l_result_bit1).bit_xor ((((((a_a < 0).to_integer).bit_shift_left (1))).bit_and (l_b_low.to_integer_32)))
						if a_a >= 0 then
							l_tmp_5 := a_a
						else
							l_tmp_5 := -a_a
						end
						l_a_limb := l_tmp_5.to_natural_32
					end
				end
			end
			if not l_return and then (l_a_limb = {NATURAL_32} 1) then
				Result := (1 - ((l_result_bit1).bit_and (2)))
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_a_ptr := l_b_ptr
					l_a_size := l_b_abs_size
					l_b := l_a_limb
					if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_a_size >= 22 then
							l_b_rem := (create {P_GMP_STATIC}).gmpn_mod_1 (l_a_ptr, l_a_size, l_b)
						else
							l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
							l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
						end
					else
						l_result_bit1 := (l_result_bit1).bit_xor (l_b.to_integer_32)
						l_b_rem := (create {P_GMP_IMPL_STATIC}).gmpn_modexact_1_odd (l_a_ptr, l_a_size, l_b)
					end
					l_break := True
				end
				l_break := False
				l_result_bit1 := (l_result_bit1).bit_xor (((l_a_limb).bit_and (l_b_low)).to_integer_32)
				Result := ((create {P_GMP_IMPL_STATIC}).gmpn_jacobi_base (l_b_rem, l_a_limb, l_result_bit1))
			end
		end

end
