class
	P_POWM_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_powm (a_r, a_b, a_e, a_m: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_b: CE_POINTER [PD_MPZ_STRUCT]
			l_n: INTEGER_32
			l_nodd: INTEGER_32
			l_ncnt: INTEGER_32
			l_cnt: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_ep: CE_POINTER [NATURAL_32]
			l_mp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_bn: INTEGER_32
			l_es: INTEGER_32
			l_en: INTEGER_32
			l_itch: INTEGER_32
			l_tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_new_b: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: INTEGER_32
			l_x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp_4: CE_POINTER [ANY]
			l_tmp_13: CE_POINTER [ANY]
			l_qp: CE_POINTER [NATURAL_32]
			l_tmp_18: CE_POINTER [ANY]
			l_tmp_20: INTEGER_32
			l_new: CE_POINTER [NATURAL_32]
			l_tmp_26: CE_POINTER [ANY]
			l_n_largest_binvert: INTEGER_32
			l_tmp_28: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_tmp_30: INTEGER_32
			l_itch_binvert_0: INTEGER_32
			l_tmp_32: INTEGER_32
			l_tmp_36: CE_POINTER [ANY]
			l_r2: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_odd_inv_2exp: CE_POINTER [NATURAL_32]
			l_t: NATURAL_32
			l_bcnt: INTEGER_32
			l_new_0: CE_POINTER [NATURAL_32]
			l_tmp_41: CE_POINTER [ANY]
			l_dst: CE_POINTER [NATURAL_32]
			l_n2: INTEGER_32
			l_tmp_43: CE_POINTER [NATURAL_32]
			l_dst_0: CE_POINTER [NATURAL_32]
			l_n_0: INTEGER_32
			l_tmp_44: CE_POINTER [NATURAL_32]
			l_dst_1: CE_POINTER [NATURAL_32]
			l_n_1: INTEGER_32
			l_tmp_45: CE_POINTER [NATURAL_32]
			l_new_1: CE_POINTER [NATURAL_32]
			l_tmp_49: CE_POINTER [ANY]
			l_dst_2: CE_POINTER [NATURAL_32]
			l_n_2: INTEGER_32
			l_tmp_51: CE_POINTER [NATURAL_32]
			l_tmp_52: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l_tmp_marker.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_new_b.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					if a_m.item.mp_size >= 0 then
						l_n := (a_m.item.mp_size).to_integer_32
					else
						l_n := (-a_m.item.mp_size).to_integer_32
					end
					if l_n = 0 then
						(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
					end
					l_mp := a_m.item.mp_d
					l_tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					l_es := (a_e.item.mp_size).to_integer_32
					if (builtin_expect ((l_es <= 0).to_integer, 0)).to_boolean then
						if l_es = 0 then
							if l_n /= 1 then
								l_tmp := 1
							elseif l_mp[0] /= {NATURAL_32} 1 then
								l_tmp := 1
							else
								l_tmp := 0
							end
							a_r.item.mp_size := l_tmp
							a_r.item.mp_d[0] := (1).to_natural_32
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_x := l_new_b
								l_x.item.mp_alloc := (l_n + 1).to_integer_32
								if (builtin_expect (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp_4 := (l_aaf.new (((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp_4 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, ((l_n + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_x.item.mp_d := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_4)
								l_break := True
							end
							l_break := False
							if not ((create {P_INVERT_STATIC}).gmpz_invert (l_new_b, l_b, a_m)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_divide_by_zero
							end
							l_b := create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_new_b)
							l_es := -l_es
						end
					end
					if not l_return then
						l_en := l_es
						if l_b.item.mp_size >= 0 then
							l_bn := (l_b.item.mp_size).to_integer_32
						else
							l_bn := (-l_b.item.mp_size).to_integer_32
						end
						if (builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean then
							a_r.item.mp_size := 0
							from
							until
								(l_break)
							loop
								l_break := False
								if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
								end
								l_break := True
							end
							l_break := False
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_ep := a_e.item.mp_d
						if l_en = 1 then
							if l_ep[0] = {NATURAL_32} 1 then
								l_tmp_20 := 1
							else
								l_tmp_20 := 0
							end
						else
							l_tmp_20 := 0
						end
						if (builtin_expect ((l_tmp_20 /= 0).to_integer, 0)).to_boolean then
							if (builtin_expect ((l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_13 := (l_aaf.new ((l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_13 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_n.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_rp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_13)
							l_bp := l_b.item.mp_d
							if l_bn >= l_n then
								if (builtin_expect ((((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
									l_tmp_18 := (l_aaf.new ((((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								else
									l_tmp_18 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (((l_bn - l_n) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
								end
								l_qp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_18);
								(create {P_GMP_STATIC}).gmpn_tdiv_qr (l_qp, l_rp, 0, l_bp, l_bn, l_mp, l_n)
								l_rn := l_n
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										not (not (l_break) and then (l_rn > 0))
									loop
										l_break := False
										if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
											l_break := True
										end
										if not (l_return or l_break) then
											l_rn := l_rn - 1
										end
									end
									l_break := False
									l_break := True
								end
								l_break := False
								if l_b.item.mp_size < 0 then
									if l_rn /= 0 then
										(create {P_GMP_STATIC}).gmpn_sub (l_rp, l_mp, l_n, l_rp, l_rn).do_nothing
										l_rn := l_n
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											from
											until
												not (not (l_break) and then (l_rn > 0))
											loop
												l_break := False
												if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
													l_break := True
												end
												if not (l_return or l_break) then
													l_rn := l_rn - 1
												end
											end
											l_break := False
											l_break := True
										end
										l_break := False
									end
								end
							elseif l_b.item.mp_size < 0 then
								(create {P_GMP_STATIC}).gmpn_sub (l_rp, l_mp, l_n, l_bp, l_bn).do_nothing
								l_rn := l_n
								l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							else
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_GMP_STATIC}).gmpn_copyi (l_rp, l_bp, l_bn)
										l_break := True
									end
									l_break := False
									l_break := True
								end
								l_break := False
								l_rn := l_bn
							end
							l_pos := -1 + 9 -- goto ret
						end
				when 2 then
						l_ncnt := (0).to_integer_32
						from
						until
							(l_break)
						loop
							l_break := False
							if not (builtin_expect ((l_mp[0] = {NATURAL_32} 0).to_integer, 0)).to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								l_mp := l_mp + 1
								l_ncnt := l_ncnt + 1
							end
						end
						l_break := False
						l_nodd := l_n - l_ncnt
						l_cnt := 0
						if l_mp[0] \\ {NATURAL_32} 2 = {NATURAL_32} 0 then
							if (builtin_expect ((l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_26 := (l_aaf.new ((l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_26 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_nodd.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_26)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_cnt := builtin_ctzl (l_mp[0])
								l_break := True
							end
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_rshift (l_new, l_mp, l_nodd, l_cnt.to_natural_32).do_nothing
							l_nodd := l_nodd - (l_new[(l_nodd - 1)] = {NATURAL_32} 0).to_integer
							l_mp := l_new
							l_ncnt := l_ncnt + 1
						end
						if l_ncnt /= 0 then
							if l_ncnt > l_nodd then
								l_tmp_28 := l_ncnt
							else
								l_tmp_28 := l_nodd
							end
							l_n_largest_binvert := l_tmp_28
							l_itch_binvert := ((create {P_GMP_IMPL_STATIC}).gmpn_binvert_itch (l_n_largest_binvert))
							if l_itch_binvert > 2 * l_n then
								l_tmp_30 := l_itch_binvert
							else
								l_tmp_30 := 2 * l_n
							end
							l_itch := 3 * l_n + l_tmp_30
						else
							l_itch_binvert_0 := ((create {P_GMP_IMPL_STATIC}).gmpn_binvert_itch (l_nodd))
							if l_itch_binvert_0 > 2 * l_n then
								l_tmp_32 := l_itch_binvert_0
							else
								l_tmp_32 := 2 * l_n
							end
							l_itch := l_n + l_tmp_32
						end
						if (builtin_expect ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp_36 := (l_aaf.new ((l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp_36 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_itch.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_36)
						l_rp := l_tp
						l_tp := l_tp + l_n
						l_bp := l_b.item.mp_d;
						(create {P_GMP_IMPL_STATIC}).gmpn_powm (l_rp, l_bp, l_bn, l_ep, l_en, l_mp, l_nodd, l_tp)
						l_rn := l_n
						if l_ncnt = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if l_bn < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_41 := (l_aaf.new ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_41 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_0 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_41)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_new_0, l_bp, l_bn)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt - l_bn /= 0 then
									l_dst := l_new_0 + l_bn
									l_n2 := l_ncnt - l_bn
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp_43 := l_dst
										l_dst := l_dst + 1
										l_tmp_43.item := (0).to_natural_32
										l_n2 := l_n2 - 1
										if not l_n2.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_bp := l_new_0
						end
						l_r2 := l_tp
						if l_bp[0] \\ {NATURAL_32} 2 /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_en > 1 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt /= 0 then
									l_dst_0 := l_r2
									l_n_0 := l_ncnt
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp_44 := l_dst_0
										l_dst_0 := l_dst_0 + 1
										l_tmp_44.item := (0).to_natural_32
										l_n_0 := l_n_0 - 1
										if not l_n_0.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 7 -- goto zero
						end
				when 5 then
						l_t := ((l_ncnt - (l_cnt /= 0).to_integer) * 32 + l_cnt.to_integer_32).to_natural_32
						l_bcnt := (((4_627).bit_shift_right (((((l_bp[0]).bit_and ({NATURAL_32} 7))).bit_shift_left (1)).to_integer_32))).bit_and (3)
						if l_ep[0] * l_bcnt.to_natural_32 >= l_t then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt /= 0 then
									l_dst_1 := l_r2
									l_n_1 := l_ncnt
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp_45 := l_dst_1
										l_dst_1 := l_dst_1 + 1
										l_tmp_45.item := (0).to_natural_32
										l_n_1 := l_n_1 - 1
										if not l_n_1.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_pos := -1 + 7 -- goto zero
						end
				when 6 then;
						(create {P_GMP_IMPL_STATIC}).gmpn_powlo (l_r2, l_bp, l_ep, l_en, l_ncnt, l_tp + l_ncnt)
				when 7 then -- zero:
						if l_nodd < l_ncnt then
							if (builtin_expect ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp_49 := (l_aaf.new ((l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp_49 := ((create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_alloc (l_tmp_marker, (l_ncnt.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_new_1 := create {CE_NATURAL_32_POINTER}.make_cast (l_tmp_49)
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False;
									(create {P_GMP_STATIC}).gmpn_copyi (l_new_1, l_mp, l_nodd)
									l_break := True
								end
								l_break := False
								l_break := True
							end
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if l_ncnt - l_nodd /= 0 then
									l_dst_2 := l_new_1 + l_nodd
									l_n_2 := l_ncnt - l_nodd
									from
									until
										(l_break)
									loop
										l_break := False
										l_tmp_51 := l_dst_2
										l_dst_2 := l_dst_2 + 1
										l_tmp_51.item := (0).to_natural_32
										l_n_2 := l_n_2 - 1
										if not l_n_2.to_boolean then
											l_break := True
										end
									end
									l_break := False
								end
								l_break := True
							end
							l_break := False
							l_mp := l_new_1
						end
						l_odd_inv_2exp := l_tp + l_n;
						(create {P_GMP_IMPL_STATIC}).gmpn_binvert (l_odd_inv_2exp, l_mp, l_ncnt, l_tp + 2 * l_n)
						if l_nodd > l_ncnt then
							l_tmp_52 := l_ncnt
						else
							l_tmp_52 := l_nodd
						end
						(create {P_GMP_STATIC}).gmpn_sub (l_r2, l_r2, l_ncnt, l_rp, l_tmp_52).do_nothing
						l_xp := l_tp + 2 * l_n;
						(create {P_GMP_IMPL_STATIC}).gmpn_mullo_n (l_xp, l_odd_inv_2exp, l_r2, l_ncnt)
						if l_cnt /= 0 then
							l_xp[(l_ncnt - 1)] := (l_xp[(l_ncnt - 1)]).bit_and (((({NATURAL_32} 1).bit_shift_left (l_cnt)) - {NATURAL_32} 1))
						end
						l_yp := l_tp
						if l_ncnt > l_nodd then
							(create {P_GMP_STATIC}).gmpn_mul (l_yp, l_xp, l_ncnt, l_mp, l_nodd).do_nothing
						else
							(create {P_GMP_STATIC}).gmpn_mul (l_yp, l_mp, l_nodd, l_xp, l_ncnt).do_nothing
						end
						(create {P_GMP_STATIC}).gmpn_add (l_rp, l_yp, l_n, l_rp, l_nodd).do_nothing
				when 8 then -- if done
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								not (not (l_break) and then (l_rn > 0))
							loop
								l_break := False
								if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
									l_break := True
								end
								if not (l_return or l_break) then
									l_rn := l_rn - 1
								end
							end
							l_break := False
							l_break := True
						end
						l_break := False
						if ((l_ep[0]).bit_and ({NATURAL_32} 1)).to_boolean then
							if l_b.item.mp_size < 0 then
								if l_rn /= 0 then
									(create {P_GMP_STATIC}).gmpn_sub (l_rp, a_m.item.mp_d, l_n, l_rp, l_rn).do_nothing
									l_rn := l_n
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										from
										until
											not (not (l_break) and then (l_rn > 0))
										loop
											l_break := False
											if l_rp[(l_rn - 1)] /= {NATURAL_32} 0 then
												l_break := True
											end
											if not (l_return or l_break) then
												l_rn := l_rn - 1
											end
										end
										l_break := False
										l_break := True
									end
									l_break := False
								end
							end
						end
				when 9 then -- ret:
						if (builtin_expect ((l_rn > (a_r.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_rn).do_nothing
						end
						a_r.item.mp_size := l_rn.to_integer_32
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_r.item.mp_d, l_rp, l_rn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (builtin_expect ((not (l_tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								(create {P_GMP_IMPL_STATIC}).gmp_tmp_reentrant_free (l_tmp_marker.item)
							end
							l_break := True
						end
						l_break := False
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
