class
	P_SIZEINBASE_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_sizeinbase (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_base: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_lb_base: INTEGER_32
			l_cnt: INTEGER_32
			l_totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp_0: INTEGER_32
			l_tmp_1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				if a_x.item.mp_size >= 0 then
					l_tmp_1 := a_x.item.mp_size
				else
					l_tmp_1 := -a_x.item.mp_size
				end
				if l_tmp_1 = 0 then
					l_result := (1).to_natural_32
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if a_x.item.mp_size >= 0 then
							l_tmp := a_x.item.mp_size
						else
							l_tmp := -a_x.item.mp_size
						end
						l_cnt := builtin_clzl (a_x.item.mp_d[(l_tmp - 1)])
						l_break := True
					end
					l_break := False
					if a_x.item.mp_size >= 0 then
						l_tmp_0 := a_x.item.mp_size
					else
						l_tmp_0 := -a_x.item.mp_size
					end
					l_totbits := l_tmp_0.to_natural_32 * {NATURAL_32} 32 - l_cnt.to_natural_32
					if ((a_base).bit_and ((a_base - 1))) = 0 then
						l_lb_base := ((create {P_GMP_IMPL_STATIC}).gmpn_bases[a_base].big_base).to_integer_32
						l_result := ((l_totbits + l_lb_base.to_natural_32) - {NATURAL_32} 1) // l_lb_base.to_natural_32
					else
						l_result := (l_totbits.to_real_64 * (create {P_GMP_IMPL_STATIC}).gmpn_bases[a_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
					end
				end
				l_break := True
			end
			l_break := False
			Result := l_result
		end

end
