class
	P_RANDOM2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpz_random2 (a_x: CE_POINTER [PD_MPZ_STRUCT]; a_size: INTEGER_32)
		local
			l_abs_size: INTEGER_32
		do
			if a_size >= 0 then
				l_abs_size := a_size
			else
				l_abs_size := -a_size
			end
			if l_abs_size /= 0 then
				if (a_x.item.mp_alloc).to_integer_32 < l_abs_size then
					(create {P_REALLOC_STATIC}).gmpz_realloc (a_x, l_abs_size).do_nothing
				end
				(create {P_GMP_STATIC}).gmpn_random2 (a_x.item.mp_d, l_abs_size)
			end
			a_x.item.mp_size := a_size.to_integer_32
		end

end
