class
	P_SET_D_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_set_d (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64)
		local
			l_d: REAL_64
			l_negative: INTEGER_32
			l_tp: CE_ARRAY [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_dst: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_tmp_1: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_32_ARRAY} l_tp.make (<<3>>)
			create l_u.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := a_d
					from
					until
						(l_break)
					loop
						l_break := False
						l_u.d := l_d
						l_u.update_class_fields -- synchronize union
						if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)).to_boolean then
							if l_u.s.manl = {NATURAL_32} 0 then
								if l_u.s.manh = {NATURAL_32} 0 then
									(create {P_GMP_IMPL_STATIC}).gmp_invalid_operation
								else
									(create {P_GMP_IMPL_STATIC}).gmp_invalid_operation
								end
							else
								(create {P_GMP_IMPL_STATIC}).gmp_invalid_operation
							end
						end
						l_break := True
					end
					l_break := False
					l_negative := (l_d < (0).to_double).to_integer
					if l_d >= (0).to_double then
						l_d := l_d
					else
						l_d := -l_d
					end
					l_rn := ((create {P_GMP_IMPL_STATIC}).gmp_extract_double (l_tp, l_d)).to_integer_32
					if (a_r.item.mp_alloc).to_integer_32 < l_rn then
						(create {P_REALLOC_STATIC}).gmpz_realloc (a_r, l_rn).do_nothing
					end
					if l_rn <= 0 then
						l_rn := (0).to_integer_32
					end
					l_rp := a_r.item.mp_d
					inspect l_rn -- switch 1 head
					when 3 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 0 then l_pos := -1 + 5
					else l_pos := -1 + 1
					end
				when 1 then -- switch 1, default:
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if l_rn - 3 /= 0 then
							l_dst := l_rp
							l_n := l_rn - 3
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp_1 := l_dst
								l_dst := l_dst + 1
								l_tmp_1.item := (0).to_natural_32
								l_n := l_n - 1
								if not l_n.to_boolean then
									l_break := True
								end
							end
							l_break := False
						end
						l_break := True
					end
					l_break := False
					l_rp := l_rp + (l_rn - 3)
				when 2 then -- switch 1, case 3l
					l_rp[2] := l_tp[2]
					l_rp[1] := l_tp[1]
					l_rp[0] := l_tp[0]
					l_pos := -1 + 6 -- switch 1; break
				when 3 then -- switch 1, case 2l
					l_rp[1] := l_tp[2]
					l_rp[0] := l_tp[1]
					l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 1l
					l_rp[0] := l_tp[2]
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, case 0l
					l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done:
					if l_negative.to_boolean then
						a_r.item.mp_size := (-l_rn).to_integer_32
					else
						a_r.item.mp_size := l_rn.to_integer_32
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
